/*---------------------------------------------
  pTv
  ---------------------------------------------*/
/*
  ZT(ZTx3EyUZTx2)̓͂ɉĂȂɔē
  ~MɂΉ
*/

#include <ud3.h>

// Ԓ`
#define turn_back_wait 500  // БyUm̌i
#define turn_turn_wait 500  // БyUm̐񎞊
#define back_back_wait 600  // yUm̌i
#define back_turn_wait 600  // yUm̐񎞊

#define L_DOHYO ((~UD3_GET_GPIOINPUT ()) & 0x01)  // yUoZT GPIO0
#define R_DOHYO ((~UD3_GET_GPIOINPUT ()) & 0x02)  // EyUoZT GPIO1

#define L_800mm ((~UD3_GET_GPIOINPUT ()) & 0x04)  // ̌oZT GPIO2
#define F_800mm ((~UD3_GET_GPIOINPUT ()) & 0x08)  // ̌oZT GPIO3
#define R_800mm ((~UD3_GET_GPIOINPUT ()) & 0x10)  // ĚoZT GPIO4

#define EMGSTOP ((~UD3_GET_GPIOINPUT ()) & 0x400) // ~M(LOWANeBu) GPIO10

bool  gSearchFlag = false;  // ̋ς邽߂̃tO(XV͓yUZT)

#define POWERGAIN 30        // o͂𒲐邽߂̃QC 0`100%Ŏw

//------------------------------------------------
//  [^[p֐
//------------------------------------------------
// ]𐮂邽߂̃[`
//  E[^(r_m2),[^(l_m1)ɃvX̒lđOi΂̂܂܂OK
//  t]Ȃ畄Ăׂ݂
void MOTOR (int16_t l_m2, int16_t r_m1) {
  r_m1 = (r_m1 * POWERGAIN) / 100;
  l_m2 = (l_m2 * POWERGAIN) / 100;

  UD3_SET_DUTY (
    -r_m1,    // E[^ւ̎wߒl
     l_m2     // [^ւ̎wߒl
  );
}

// Oi
void forward (int16_t pow) {
  MOTOR (abs(pow), abs(pow));
}

// 
void back (int16_t pow) {
  MOTOR (-abs(pow), -abs(pow));
}

// ~
void stop (void) {
  MOTOR (0, 0);
}

// MnE
void right_turn (int16_t pow) {
  MOTOR (abs(pow), -abs(pow));
}

// Mn
void left_turn (int16_t pow) {
  MOTOR (-abs(pow), abs(pow));
}

// EJ[u
void turn (int16_t l_pow, int16_t r_pow) {
  MOTOR (abs(l_pow), abs(r_pow));
}

// ԂɂMnE
void right_turn_time (uint32_t t) {
  right_turn (1000);
  UD3_WAIT (t);
  stop ();
}

// ԂɂMn
void left_turn_time (uint32_t t) {
  left_turn (1000);
  UD3_WAIT (t);
  stop ();
}

// Ԃɂi
void back_time (uint32_t t) {
  back (1000);
  UD3_WAIT (t);
  stop ();
}

//---------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------
// ZT̐MGPIO0`4,10Ŏ荞ނ߂̏ƁA[^̋쓮ݒB
// 肵쓮]ޏꍇ̓v֐̌zƗǂB
//---------------------------------------------------------------------------------
UD3_INITIALIZE () {
  UD3_CFG_GPIO0 (GPIO_IN_PULLUP_ON);  // yUpZT[
  UD3_CFG_GPIO1 (GPIO_IN_PULLUP_ON);  // yUpZT[E
  UD3_CFG_GPIO2 (GPIO_IN_PULLUP_ON);  // ΕZT[
  UD3_CFG_GPIO3 (GPIO_IN_PULLUP_ON);  // ΕZT[
  UD3_CFG_GPIO4 (GPIO_IN_PULLUP_ON);  // ΕZT[E
  UD3_CFG_GPIO10 (GPIO_IN_PULLUP_ON); // ً}~

  // PWMg80kHz
  UD3_SET_M1FREQUENCY (80);
  UD3_SET_M2FREQUENCY (80);
  // PWMő吧93%(100%-7%)
  // tp[ɕsȋꍇ͂̒l傫
  UD3_SET_M1RECHARGE (7);
  UD3_SET_M2RECHARGE (7);
  // 쓮[hݒ
  UD3_SET_M1DRIVEMODE (_UD_MOTOR_DRIVE);
  UD3_SET_M2DRIVEMODE (_UD_MOTOR_DRIVE);
  // [^̉]w
  //   [^̍EM1,M2̑Ή̓P[u̓ւ
  //   t̉]݈̂ȉ̊֐őΉ
  //    0:M1,M2ƂftHg
  //    1:M1̂ݔ]
  //    2:M2̂ݔ]
  //    3:M1,M2ɔ]
  UD3_SET_MOTORREVRSE (0);
  // vo͂̌z50/ms
  UD3_SET_MOTORRAMP (50);

  // ^XN1,2N
  UD3_ACTIVE_TASK (1);
  UD3_ACTIVE_TASK (2);
}

//---------------------------------------------------------------------------------
// 킢^XN
//---------------------------------------------------------------------------------
UD3_TASK1 () {
  int  i = 0;
  char led = 0;

  UD3_SET_BUZZER (20, 10);
  UD3_WAIT (100);
  UD3_SET_BUZZER (30, 10);

  // PB1ȂPB2܂ő҂
  while (1) {
    if ((i++ % 50) == 0) UD3_SET_LED (led = !led);
    if (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()) break;
    UD3_WAIT (10);
  }
  UD3_WAIT (10);

  // PB1ȂPB2܂ő҂
  while (1) {
    if ((i++ % 10) == 0) {
      UD3_SET_LED (led = !led);
      UD3_SET_BUZZER (60, 5);
    }
    if (!(UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ())) break;
    UD3_WAIT (5);
  }

  UD3_SET_LED (1);

  UD3_WAIT (1000);
  UD3_SET_BUZZER (15, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (15, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (20, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (20, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (32, 70);

  // [^쓮
  UD3_SET_MOTORENABLE (true);

  // p^[KvȂ炱ɂłLq
  switch (UD3_GET_DIPSWICH ()) {
    case 0:
      break;
    case 1:
      break;
    case 2:
      break;
    case 3:
      break;
    case 4: // Kȗ
      left_turn_time (500);
      right_turn (1000);
      break;
  }

  while (1) {
    int L, F, R;

    L = L_DOHYO;  R = R_DOHYO;
    // EyUZTĂƂ
    if (!L && R) {
      back_time (turn_back_wait);       //   
      left_turn_time (turn_turn_wait);  //   
    // yUZTĂƂ
    } else if (L && !R) {
      back_time (turn_back_wait);       //   
      right_turn_time (turn_turn_wait); //   E
    // yUZTĂƂ
    } else if (L && R) {
      back_time (back_back_wait);       //   
      left_turn_time (back_turn_wait);  //   
    // yUZTĂȂƂ
    } else {
      L = L_800mm;  F = F_800mm;  R = R_800mm;
      if      (!L && !F &&  R) right_turn (1000); // EZT̂ݔ    E
      else if (!L &&  F && !R) forward (1000);    // ʃZT̂ݔ  Oi
      else if (!L &&  F &&  R) turn (1000, 500);  // EEʃZT  EɑOi
      else if ( L && !F && !R) left_turn (1000);  // ZT        
      else if ( L && !F &&  R) forward (1000);    // EEZT    Oi
      else if ( L &&  F && !R) turn (500, 1000);  // EʃZT  ɑOi
      else if ( L &&  F &&  R) forward (1000);    // SZT        Oi
      else forward (800);                         // SZTȂ    Oi
    }
  }
}

//---------------------------------------------------------------------------------
// ~Ď^XN
//---------------------------------------------------------------------------------
UD3_TASK2 () {
  while (1) {
    // [^Cl[uԂňȉ̏ꂩoƒ~
    //   GPIO10LOWM
    //   PB1ȂPB20.2bȏ㉟
    if (UD3_GET_MOTORENABLE () && (EMGSTOP || (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()))) {
      UD3_WAIT (200);
      // 0.2bɂxMmF(댟m΍)
      if (UD3_GET_MOTORENABLE () && (EMGSTOP || (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()))) {
        while (1) {
          // [^쓮~
          UD3_SET_MOTORENABLE (false);
          UD3_SET_BUZZER (50, 20);

          UD3_SET_LED (1);
          UD3_WAIT (250);

          UD3_SET_LED (0);
          UD3_WAIT (250);
        }
      }
    }
    UD3_WAIT (10);
  }
}
