/*---------------------------------------------
  DUALSHOCK3pTv2
  ---------------------------------------------*/
/*
  DUALSHOCK3̍AiOXeBbNEL[EL1/L2L[ELL[gĉ^]
*/

#include <ud3.h>

#define LEFT    0x80
#define DOWN    0x40
#define RIGHT   0x20
#define UP      0x10

#define R1      0x08
#define L1      0x04

#define SQUARE  0x80
#define CROSS   0x40
#define CIRCLE  0x20
#define TRIANGL 0x10

#define POWERGAIN 30        // o͂𒲐邽߂̃QC 0`100%Ŏw

//---------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------
// M@̐MGPIO8,9Ŏ荞ނ߂̏ƁA[^̋쓮ݒB
// 肵쓮]ޏꍇ̓v֐̌zƗǂB
//---------------------------------------------------------------------------------
UD3_INITIALIZE () {
  // PWMg80kHz
  UD3_SET_M1FREQUENCY (100);
  UD3_SET_M2FREQUENCY (100);
  // PWMő吧93%(100%-7%)
  UD3_SET_M1RECHARGE (7);
  UD3_SET_M2RECHARGE (7);
  // 쓮[hݒ
  UD3_SET_M1DRIVEMODE (_UD_MOTOR_DRIVE);
  UD3_SET_M2DRIVEMODE (_UD_MOTOR_DRIVE);
  // vo͂̌z50/ms
  UD3_SET_MOTORRAMP (50);

  UD3_ACTIVE_TASK (1);
}

//---------------------------------------------------------------------------------
// DUALSHOCK3̒ʒusȂ̂ŕsт݂邽߂̉Z[`
//---------------------------------------------------------------------------------
// łɈʒu}1000ɐK
//---------------------------------------------------------------------------------
int calc (int v, int home, int max) {
  v = (v * 2000) / 255 - 1000;
  home = 10 * home;
  max = 1000 - (10 * max);
  if     (v > max) return 1000;
  else if(v < -max) return -1000;
  else if((v> -home) && (v < home)) return 0;
  else if(v <= -home) return -((abs(v) - home) * 1000) / (max - home);
  else if(v >= home) return ((v - home) * 1000) / (max - home);
  return  v;
}

//---------------------------------------------------------------------------------
// ̃AiOXeBbNyѕL[ɂ^]^XN
//---------------------------------------------------------------------------------
UD3_TASK1 () {

  void MOTOR (int16_t l_m2, int16_t r_m1) {
    r_m1 = (r_m1 * POWERGAIN) / 100;
    l_m2 = (l_m2 * POWERGAIN) / 100;

    UD3_SET_DUTY (
      -r_m1,    // E[^ւ̎wߒl
       l_m2     // [^ւ̎wߒl
    );
  }

  int connectdelay = 0;
  uint32_t  starttime = 0, continuancetime, t;
  bool led = false;
  uint8_t btn;

  // N
  UD3_SET_BUZZER (20, 10);
  UD3_WAIT (100);
  UD3_SET_BUZZER (30, 10);

  while (1) {
    // fBbvXCb`Ń[^̉]ύX
    UD3_SET_MOTORREVRSE (UD3_GET_DIPSWICH() & 3);

    // PB2Ń[^쓮ꎞ~ xPB2Ɣ
    if (UD3_GET_PUSHBUTTON2 ()) {
      starttime = 0;
      UD3_WAIT (10);
      while (UD3_GET_PUSHBUTTON2 ());

      UD3_SET_MOTORENABLE (false);
      UD3_SET_LED (0);
      UD3_WAIT (100);

      while (!UD3_GET_PUSHBUTTON2 ());
      UD3_WAIT (10);
      while (UD3_GET_PUSHBUTTON2 ());
      UD3_WAIT (10);
    // {^ĂȂ΃XeBbN̈ʒuɉă[^쓮
    } else {
      if (UD3_GET_BTCONNECT ()) {
        // ڑm͒lsȂ̂ŐڑĂ1bx͓Ȃ
        if (connectdelay++ < 10) {
          UD3_SET_MOTORENABLE (false);
          // LED_
          UD3_SET_LED (led = !led);
          UD3_WAIT (100);

          starttime = UD3_GET_ELAPSEDTIME ();
        } else {
          connectdelay = 10;
          // LED_
          UD3_SET_LED (1);
          // [^쓮
          UD3_SET_MOTORENABLE (true);

          // ̃AiOXeBbNX/Y[^Ɋ蓖Ăĉ^]
          int x = -calc (UD3_GET_PSLX (), 25, 0);
          int y = -calc (UD3_GET_PSLY (), 25, 0);

          // AiOXeBbN|Ă
          if (x != 0 || y != 0) {
            // YAChʒu -> 
            if (y == 0)       MOTOR (-x, x);
            // XAChʒu -> iE
            else if (x == 0)  MOTOR (y, y);
            // E
            else if (x > 0)   MOTOR (y * (1000 - x) / 1000, y);
            // 
            else if (x < 0)   MOTOR (y, y * (1000 + x) / 1000);

            starttime = UD3_GET_ELAPSEDTIME ();
          }
          // AiOXeBbNŕL[ȂR1,R2ꂽ
          else if ((btn = (UD3_GET_PSDIGITAL1 () & 0xf0) | (UD3_GET_PSDIGITAL2 () & 0x0c))) {
            switch (btn) {
              case UP:            MOTOR ( 1000,  1000);  break;  // Oi
              case UP | RIGHT:    MOTOR ( 1000,   700);  break;  // OEJ[u1
              case RIGHT:         MOTOR ( 1000,   300);  break;  // OEJ[u2
              case R1:            MOTOR ( 1000, -1000);  break;  // EMn
              case RIGHT | DOWN:  MOTOR (-1000,  -500);  break;  // EJ[u
              case DOWN:          MOTOR (-1000, -1000);  break;  // 
              case DOWN | LEFT:   MOTOR ( -500, -1000);  break;  // ㍶J[u
              case L1:            MOTOR (-1000,  1000);  break;  // Mn
              case LEFT:          MOTOR (  300,  1000);  break;  // J[u2
              case LEFT | UP:     MOTOR (  700,  1000);  break;  // J[u1
            }

            starttime = UD3_GET_ELAPSEDTIME ();
          // AiOXeBbNL[ŋLL[ꂽ
          } else if ((btn = (UD3_GET_PSDIGITAL2 () & 0xf0))) {
            // {^ĂԂ̎Ԃv
            continuancetime = UD3_GET_ELAPSEDTIME () - starttime;
            switch (btn) {
              // EɐUȂ炦
              case TRIANGL:
                t = continuancetime % 100;
                if (t >= 0 && t <= 50) MOTOR (1000,  300);
                else MOTOR (300, 1000);
                break;
              // OiȂ炦
              case CROSS:
                t = continuancetime % 100;
                if (t >= 0 && t <= 70) MOTOR (1000,  1000);
                else MOTOR (300,  300);
                break;
              // E荞ł݂
              case CIRCLE:
                // 0.3bԂEMn (90x炢ȂƂ)
                if (continuancetime <= 300) {
                  MOTOR (1000, -1000);
                // Ȍ͉EJ[u`
                } else if (continuancetime > 200) {
                  MOTOR (500, 1000);
                }
                break;
              // 荞ł݂
              case SQUARE:
                // 0.3bԂMn (90x炢ȂƂ)
                if (continuancetime <= 300) {
                  MOTOR (-1000, 1000);
                // Ȍ͍J[u`
                } else if (continuancetime > 200) {
                  MOTOR (1000,  500);
                }
                break;
            }
          // 삳ĂȂ
          } else {
            MOTOR (0, 0);
            starttime = UD3_GET_ELAPSEDTIME ();
          }
        }
      } else {
        connectdelay = 0;
        UD3_SET_MOTORENABLE (false);
        // LED_
        UD3_SET_LED (led = !led);
        UD3_WAIT (100);
      }
    }
  }
}
