/*---------------------------------------------
  [^쓮Tv
  ---------------------------------------------*/
#include <ud3.h>

// M1ɐݒ肳ꂽf[eB[l擾}N
#define UD3_GET_M1DUTY()       ((int16_t)ud_ReadMemoryWord ((_ADDR_M1PWMDUTY)))
// M2ɐݒ肳ꂽf[eB[l擾}N
#define UD3_GET_M2DUTY()       ((int16_t)ud_ReadMemoryWord ((_ADDR_M2PWMDUTY)))

//---------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------
UD3_INITIALIZE () {
  // DynamixelpPbg~
  //  pPbgʐM펞sꍇUD3_PRINTF͎gȂ
  UD3_SET_DXPACKETENABLE (false);

  // PWMg80kHz
  UD3_SET_M1FREQUENCY (80);
  UD3_SET_M2FREQUENCY (80);
  // PWMő吧93%(100%-7%)
  // tp[ɕsȋꍇ͂̒l傫
  UD3_SET_M1RECHARGE (7);
  UD3_SET_M2RECHARGE (7);
  // 쓮[hݒ
  UD3_SET_M1DRIVEMODE (_UD_MOTOR_DRIVE);
  UD3_SET_M2DRIVEMODE (_UD_MOTOR_DRIVE);
  // [^̉]w
  //   [^̍EM1,M2̑Ή̓P[u̓ւ
  //   t̉]݈̂ȉ̊֐őΉ
  //    0:M1,M2ƂftHg
  //    1:M1̂ݔ]
  //    2:M2̂ݔ]
  //    3:M1,M2ɔ]
  UD3_SET_MOTORREVRSE (0);

  // vo͂̌z1/ms
  UD3_SET_MOTORRAMP (1);

  // ^XN1,2N
  UD3_ACTIVE_TASK (1);
  UD3_ACTIVE_TASK (2);
}

//---------------------------------------------------------------------------------
// ^XN1
//---------------------------------------------------------------------------------
UD3_TASK1 () {
  char led = 0;
  int m1 = 0, m2 = 0, dual = 0;
  bool f1 = true, f2 = true, fd = true;

  while (1) {
    // M1M2𓯎ɉ^]
    if (UD3_GET_PUSHBUTTON1 () && UD3_GET_PUSHBUTTON2 ()) {
      if (fd) {
        dual += 10;
        if (dual > 1000) fd = false;
      } else {
        dual -= 10;
        if (dual < -1000) fd = true;
      }
      // Q[gCl[u
      UD3_SET_MOTORENABLE (true);
      // M1M2Ƀf[eB[ݒ
      UD3_SET_DUTY (dual, dual);
    } else
    // M1̂݉^]
    if (UD3_GET_PUSHBUTTON1 ()) {
      if (f1) {
        m1 += 10;
        if (m1 > 1000) f1 = false;
      } else {
        m1 -= 10;
        if (m1 < -1000) f1 = true;
      }
      // Q[gCl[u
      UD3_SET_MOTORENABLE (true);
      // M1Ƀf[eB[ݒ
      UD3_SET_M1PWMDUTY (m1);
      // M2Ƀf[eB[ݒ
      UD3_SET_M2PWMDUTY (0);
    } else
    // M2̂݉^]
    if (UD3_GET_PUSHBUTTON2 ()) {
      if (f2) {
        m2 += 10;
        if (m2 > 1000) f2 = false;
      } else {
        m2 -= 10;
        if (m2 < -1000) f2 = true;
      }
      // Q[gCl[u
      UD3_SET_MOTORENABLE (true);
      // M1Ƀf[eB[ݒ
      UD3_SET_M1PWMDUTY (0);
      // M2Ƀf[eB[ݒ
      UD3_SET_M2PWMDUTY (m2);
    } else
      UD3_SET_MOTORENABLE (false);

    // Q[gONLED_
    UD3_SET_LED (UD3_GET_MOTORENABLE() ? (led = !led) : 0);

    // ݂̐ݒl\
    UD3_PRINTF (
      "M1:%5d   M2:%5d   GATE:%s\r",
      UD3_GET_M1DUTY(),
      UD3_GET_M2DUTY(),
      UD3_GET_MOTORENABLE() ? "ON " : "OFF"
    );
    UD3_WAIT (50);
  }
}
